//   fft.h - declaration of class
//   of fast Fourier transform - FFT
//
//   The code is property of LIBROW
//   You can use it on your own
//   When utilizing credit LIBROW site
//   
//   The following modifications (c) 2015 Ralph Schenn
//   - port from C++ to C
//   - port to TI-89 pocket calculator

#include <tiams.h>
#include "Complex.h"
 
#ifndef _FFT_H_
#define _FFT_H_
 
#define FORWARD 1
#define INVERSE -1

/* fast fourier transform */
void fft(void);
 
/* FOURIER TRANSFORM, INPLACE VERSION
Data  - both input data and output
N     - length of both input data and result */
Boolean FFT(Complex Data[], 
	const unsigned short N, 
	const Boolean Inverse);
	
/* non-destructive fourier transform */
HANDLE FFTNonDes(Complex Data[],
	const unsigned short N,
	const Boolean Inverse);
  
#endif
