/*
		convolution by FFT
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>

#ifndef _FFTCONV_H_
#define _FFTCONV_H_

/* convolution by FFT
This may be slow when length of x and h are quite different
(in that case the overlap-add method should give better performance but adds algorithmic complexity also) */
void fconv(void);

/* convolution by FFT
(this is linear and not circular
Dereferencing x and h gives pointers to array of Complex
Result is in x, its original content is overwritten */
void FFTConv(HANDLE x,
	unsigned short lx,
	HANDLE h,
	unsigned short lh);

#endif
