/*
		multi expressions
		
    Copyright (C) 2013  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MULTIEXPR_H_
#define _MULTIEXPR_H_

#include <tiams.h>
#include "ROM.h"
 
/* extract reference from source code 
returns string with the format folder\\variable */
HANDLE GetPath(const char *expr, 
	unsigned short length, 
	unsigned short backSlash);

/* returns array of strings with user defined function references 
contained in variable 
the format of the strings is folder\\var */
unsigned short GetReferences(HANDLE *refs, 
	SYM_ENTRY *symptr);

/* check if variable is a file (not a folder) */
Boolean IsFile(SYM_ENTRY *symptr);

/* check if variable is a function or program */
Boolean IsFuncOrProg(SYM_ENTRY *symptr);

/* check if expr contains str
str must be null-terminated */
Boolean MultiExprContStr(MULTI_EXPR *expr, 
	const char *str);

/* find begin of path */
unsigned short PathBegin(const char *expr, 
	unsigned short backSlash);
 
/* find end of path */
unsigned short PathEnd(const char *expr, 
	unsigned short length, 
	unsigned short backSlash); // ok

/* variable contains string */
Boolean SymEntryContStr(SYM_ENTRY *symptr, 
	const char *str);

/* check if called function/program exists */
Boolean VarExists(const char *path);

#endif
