/* (c) Texas Instruments 
these are examples from "TI-89 / TI-92 Plus Developer Guide" */
 
#include <tiams.h>

/* If i indexes x^-(3/2) + ln(y), then is_polynomial_in_var_or_kern returns
TRUE if vi indexes x or ln(y) or z, but returns FALSE if vi indexes y. (page 297) */
Boolean is_polynomial_in_var_or_kern (EStackIndex i, 
	EStackIndex vi)
{ 
	Access_AMS_Global_Variables;
	
	for ( ; ; ) { 
		if (are_expressions_identical (i, vi) ||
		IS_NUM_VAR_OR_ZERO_ARG_TAG (ESTACK (i))) {
			return TRUE;
		}
			
		if (EXPONENTIATION_TAG == ESTACK (i) &&
		!(are_expressions_identical (vi, POWER_BASE_INDEX (i)) ||
		is_whole_number (POWER_EXPONENT_INDEX (i)) ||
		is_independent_of (POWER_BASE_INDEX (i), vi) )) {
			return FALSE;
		}
			
		if (IS_ARITH_OR_POWER_TAG (ESTACK (i)) &&
		is_polynomial_in_var_or_kern (i - 1u, vi)) {
			i = next_expression_index (i - 1u);
		} else {
			return is_independent_of (i, vi);
		}
	}
}

/* i indexes a polynomial in kernel ki.
Pushes a tail of its coefficients (including zero-coefficients),
with the constant coefficient deepest. (page 511) */
void push_coef_list(EStackIndex i, 
	EStackIndex ki)
{
	Access_AMS_Global_Variables;

	EStackIndex j, ans;

	push_quantum (END_TAG);
	ans = top_estack;
	push_expression (i);
	i = top_estack;

	while (!is_independent_of (i, ki)) { 
		push_substitute_simplify (i, ki, Integer0Index);
		j = top_estack;
		push_difference (i, j);
		divide_top (ki);
		ans = j - deleted_between (ans, i);
		i = top_estack;
	}
}
