#include <tiams.h>
#include "Debug.h"
#include "Stack.h"

static void Swap(EStackIndex v[], 
	int i, 
	int j)
{
	EStackIndex temp;
	
	temp = v[i];
	v[i] = v[j];
	v[j] = temp;
}
/*static void Swap(double v[], 
	int i, 
	int j)
{
	double temp;
	
	temp = v[i];
	v[i] = v[j];
	v[j] = temp;
}*/

/* qsort: sort v[left]...v[right] into increasing order 
Kernighan & Ritchie: The C programming language */
void QSort(EStackIndex v[], 
	short left, 
	short right)
{
	short i, last;

	// do nothing if array contains
	if (left >= right) {
		// fewer than two elements
		return; 
	}
		
	// move partition elem
	Swap (v, left, (left + right) / 2);
	
	// to v[0]
	last = left; 
	
	// partition
	for (i = left + 1; i <= right; i++) {
		if (compare_expressions (v[i], v[left]) < 0) {
			Swap (v, ++last, i);
		}
	}
			
	// restore partition elem
	Swap (v, left, last);
	QSort (v, left, last - 1);
	QSort (v, last + 1, right);
}
/*void QSort(double v[], 
	short left, 
	short right)
{
	short i, last;

	// do nothing if array contains
	if (left >= right) {
		// fewer than two elements
		return; 
	}
		
	// move partition elem
	Swap (v, left, (left + right) / 2);
	
	// to v[0]
	last = left; 
	
	// partition
	for (i = left + 1; i <= right; i++) {
		if (v[i] < v[left]) {
			Swap (v, ++last, i);
		}
	}
			
	// restore partition elem
	Swap (v, left, last);
	QSort (v, left, last - 1);
	QSort (v, last + 1, right);
}*/
