 /*
		real functions
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>
#include "Real.h"

/* round to next smallest power of two */
unsigned int CeilPow2(unsigned int x)
{
    return pow (2, ceil (Log2 (x)));
}

/* check if number is power of 2 */
Boolean IsPow2(unsigned int x)
{
	return !(x & (x - 1));
}

/* binary logarithm */
double Log2(double x)
{
	return log (x) / log (2);
}

/* max of two numbers */
int Max(int a, int b)
{
	return a > b ? a : b;
}

/* random number between 1 and RAND_MAX */
unsigned short Rand(void)
{
    Access_AMS_Global_Variables;
    
    unsigned short r;
    
    push_ushort_to_integer (RAND_MAX);
        
    push_rand (top_estack);
    
    estack_to_ushort (top_estack, &r);

	return r;
}


