/*
		Generic wrapper functions
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _WRAPPER_H_
#define _WRAPPER_H_

/* execute function for all arguments 
function to be executed 
simplify the arguments 
requires arguments */
void ExecFuncArgs(void (*funcPtr)(EStackIndex),
	Boolean simp, 
	Boolean reqArgs);

/* Wrapper for functions with expression and variable 
function to call (returning bool or void) 
called function returns list 
function does not push its result implicitly */
void ExprVar(Boolean (*funcPtr)(EStackIndex, EStackIndex),
	Boolean list,
	Boolean push);

/* call func with one expr parameter */
void IsExpr(Boolean (*funcPtr)(EStackIndex i));

/* function receiving list and integer */
void LstIntFunc(void (*funcPtr)(double [], unsigned short, unsigned short, double []));

/* intersection or difference of lists
map_tail is not suitable here because callback function also needs pointer to other list */
void LstIntSub(Boolean sub);

/* odd or even elements of list */
void LstOddEven(Boolean odd);

/* proccess all arguments of list with passed function */ 
void MapTail(void (*funcPtr) (EStackIndex));

/* wrapper for functions requiring real arguments
handles matrices, lists or scalars */ 
void RealFunc(void (*funcPtr)(EStackIndex));

/* string function with one arg wrapper */
void StrFunc(const char * (*funcPtr)(const char *));

/* set arbitary number */
void SetArb(Boolean integer);

#endif
